<template>
<div class="main_app">
    <div class="header">
        <h1><img class="logo" src="/csdc-logo.svg" /> CSDC Download Helper</h1>
    </div>

    <h2>Please select your manifest file to load...</h2>
    <input type="file" v-bind="files" @change="loadManifest($event.target.name, $event.target.files)"
            class="input-file">
    <div class="actions" v-if="manifestLoaded">
        <ul class="nav-list">
            <li>
                <button class="btn" @click="startDownload">Start Download</button>
            </li>
        </ul>
    </div>
</div>
</template>

<script>
var client;
 export default {
    name: "fileSelectorView",
    data () {
      return {
        manifestLoaded: false,
        files: null
      };
    },
    created(){
      if( navigator.userAgent.includes('Chrome') ){
        client = chrome;
      }else{
        client = browser;
      }
      client.runtime.onMessage.addListener((request) => {
        if (request.action && request.action === 'clearManifest') {
          window.close();
        }
      });
    },
    methods: {
      startDownload() {
        client.runtime.sendMessage({action: 'startDownload'});
        setTimeout(()=>{
          window.close();
        }, 500);
      },
      loadManifest(name, files) {
        console.log('loadManifest')
        const [file] = files;
        const reader = new FileReader();
        console.log(name);
        reader.addEventListener(
          "load",
          () => {
            // this will then display a text file
            try{
              const data = JSON.parse(reader.result);
              client.runtime.sendMessage({action:'manifestFileLoaded', files: data});
              this.manifestLoaded = true;
            }catch{
              this.errMsg = "Unable to parse file contents";
            }
          },
          false
        );

        if (file) {
          reader.readAsText(file);
        }

      }
    }
 }

</script>

<style>
@import '../assets/main.css';
#app{
  display: flex;
  align-items: center;
  justify-content: center;
}
</style>
